%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LEAD-LAG-REGLERENTWURF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
close all;
clear all;

%Strecke
s = tf('s');  
G = 1.8*(1+s/1.8)/s/(1+2*0.8*(s/2.8)+(s/2.8)^2)

%Anforderungen an die Sprungantwort des geschlossenen Regelkreises
tr = 0.1;
ue = 20;
einf = 0.01;

%Anforderungen an das Bodediagramm des offenen Regelkreises
wc = 1.5/tr;
phi = 70-ue;
%Verstrkung des offenen Regelkreises
VL = 1/einf;

%%
%Reglerverstrkung
VR = VL/1.8;

%Bodediagramm von L1
L1 = G*VR;
figure(1);
bode(L1);
grid on;

%Entwurf des Lead-Gliedes
L1_wc = freqresp(L1,wc);
dphi = -(180-phi-10)*pi/180-angle(L1_wc);
eta1 = (tan(pi/4-dphi/2))^2;
T1 = 1/(sqrt(eta1)*wc);

%Bodediagramm von L1
L2 = L1*(1+T1*s)/(1+eta1*T1*s);
figure(2);
bode(L1,L2);
grid on;
%Test, dass die Phase an der Durchtrittsfrequenz korrekt ist
disp(['Phase an Durchtrittsfrequenz: ',num2str(angle(freqresp(L2,i*wc))*180/pi)]);

%Entwurf des Lag-Gliedes
dphi=-10*pi/180;
da=1/abs(freqresp(L2,wc));
T2 = (da*sqrt(tan(dphi)^2+1)-1)/tan(dphi)/wc;
eta2 = (wc*T2-tan(dphi))/wc/T2/(1+wc*T2*tan(dphi));

%Bodediagramm des offenen Regelkreises
L = L2*(1+T2*s)/(1+eta2*T2*s);
figure(3);
bode(L1,L2,L);
grid on;

%Test, dass Betrag und Phase an der Durchtrittsfrequenz korrekt sind 
disp(['Phase an Durchtrittsfrequenz: ',num2str(angle(freqresp(L,wc))*180/pi)]);
disp(['Betrag an Durchtrittsfrequenz: ',num2str(abs(freqresp(L,wc)))]);

%Sprungantwort des geschlossenen Regelkreises
T = feedback(L,1);
figure(4);
step(T,1);
grid on;

%Rampenantwort des geschlossenen Regelkreises
figure(5);
step(T/s,1);
hold on;
t = 0:0.01:1;
plot(t,t,'g');
grid on;
    