%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PI-REGLERENTWURF (Abschnitt 5.1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
close all;
clear all;

%Strecke
s = tf('s');  
G = 5/(1+2*0.707*s+s^2)

%Anforderungen an die Sprungantwort des geschlossenen Regelkreises
tr = 3;
ue = 10;

%Anforderungen an das Bodediagramm des offenen Regelkreises
wc = 1.5/tr;
phi = 70-ue;

%%
%Bodediagramm von L1
L1 = G/s;
figure(1);
bode(L1);
grid on;

%Auswertung von L1 an der Stelle i*wc
L1_wc = freqresp(L1,wc);

%Phasenanhebung
TI = tan((-180+phi)*pi/180-angle(L1_wc))/wc;

%Betragskorrektur
L2 = L1*(1+TI*s);
L2_wc = freqresp(L2,wc);
VI = 1/abs(L2_wc);

%Bodediagramm des offenen Regelkreises
L = L2*VI;
figure(2);
bode(L1,L);
grid on;

%Sprungantwort des geschlossenen Regelkreises
T = feedback(L,1);
figure(3);
step(T,20);
grid on;